# http://www.igvita.com/2008/08/10/asynchronous-db-dbslayer-httpasynchronous-db-dbslayer-http

require 'rubygems'
require 'eventmachine'
require 'evma_httpserver'
require 'mysql'

class Handler  < EventMachine::Connection
  include EventMachine::HttpServer
  attr_accessor :db
 
  def process_http_request
    resp = EventMachine::DelegatedHttpResponse.new( self )
    
    response = ""
    @db.query("SELECT sleep(1)").each_hash { |row|
      response += row.inspect + "\n"
    }
    
    resp.status = 200
    resp.content = response
    resp.send_response
  end
end
 
EventMachine.epoll
EventMachine::run {
  @db = Mysql.real_connect('localhost', 'root', '', 'dbslayer', 3360)

  EventMachine::start_server("0.0.0.0", 8080, Handler) { |conn| conn.db = @db }
  puts "Listening..."
}
